#ifndef A_B_TEMPLATE
#define A_B_TEMPLATE

#include <type_traits>

namespace A
{
namespace B
{
   template <class T> class AClass;
   
   template<class T>
   class Base
   {
   };
   
   /*!
   Random class doc.
   */
   template<class T1, class T2>
   class C final : public Base<T1>
   {
   public:
      static_assert(!std::is_same<T1, T2>::value, "static_assert");

      using MyClass = AClass<T2>;
      explicit C(const MyClass &aClass);
   };
}
}

#endif